# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.apimanagement import ApiManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer, recorded_by_proxy

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestApiManagementApiGatewayConfigConnectionOperations(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(ApiManagementClient)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_api_gateway_config_connection_list_by_gateway(self, resource_group):
        response = self.client.api_gateway_config_connection.list_by_gateway(
            resource_group_name=resource_group.name,
            gateway_name="str",
            api_version="2024-05-01",
        )
        result = [r for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_api_gateway_config_connection_get(self, resource_group):
        response = self.client.api_gateway_config_connection.get(
            resource_group_name=resource_group.name,
            gateway_name="str",
            config_connection_name="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_api_gateway_config_connection_begin_create_or_update(self, resource_group):
        response = self.client.api_gateway_config_connection.begin_create_or_update(
            resource_group_name=resource_group.name,
            gateway_name="str",
            config_connection_name="str",
            parameters={
                "defaultHostname": "str",
                "etag": "str",
                "hostnames": ["str"],
                "id": "str",
                "name": "str",
                "provisioningState": "str",
                "sourceId": "str",
                "type": "str",
            },
            api_version="2024-05-01",
        ).result()  # call '.result()' to poll until service return final result

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_api_gateway_config_connection_begin_delete(self, resource_group):
        response = self.client.api_gateway_config_connection.begin_delete(
            resource_group_name=resource_group.name,
            gateway_name="str",
            config_connection_name="str",
            if_match="str",
            api_version="2024-05-01",
        ).result()  # call '.result()' to poll until service return final result

        # please add some check logic here by yourself
        # ...
