# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.apimanagement import ApiManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer, recorded_by_proxy

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestApiManagementAuthorizationAccessPolicyOperations(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(ApiManagementClient)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_authorization_access_policy_list_by_authorization(self, resource_group):
        response = self.client.authorization_access_policy.list_by_authorization(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            api_version="2024-05-01",
        )
        result = [r for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_authorization_access_policy_get(self, resource_group):
        response = self.client.authorization_access_policy.get(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            authorization_access_policy_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_authorization_access_policy_create_or_update(self, resource_group):
        response = self.client.authorization_access_policy.create_or_update(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            authorization_access_policy_id="str",
            parameters={
                "appIds": ["str"],
                "id": "str",
                "name": "str",
                "objectId": "str",
                "tenantId": "str",
                "type": "str",
            },
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_authorization_access_policy_delete(self, resource_group):
        response = self.client.authorization_access_policy.delete(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            authorization_access_policy_id="str",
            if_match="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...
