# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.apimanagement.aio import ApiManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer
from devtools_testutils.aio import recorded_by_proxy_async

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestApiManagementAuthorizationOperationsAsync(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(ApiManagementClient, is_async=True)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_authorization_list_by_authorization_provider(self, resource_group):
        response = self.client.authorization.list_by_authorization_provider(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            api_version="2024-05-01",
        )
        result = [r async for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_authorization_get(self, resource_group):
        response = await self.client.authorization.get(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_authorization_create_or_update(self, resource_group):
        response = await self.client.authorization.create_or_update(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            parameters={
                "authorizationType": "str",
                "error": {"code": "str", "message": "str"},
                "id": "str",
                "name": "str",
                "oauth2grantType": "str",
                "parameters": {"str": "str"},
                "status": "str",
                "type": "str",
            },
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_authorization_delete(self, resource_group):
        response = await self.client.authorization.delete(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            if_match="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_authorization_confirm_consent_code(self, resource_group):
        response = await self.client.authorization.confirm_consent_code(
            resource_group_name=resource_group.name,
            service_name="str",
            authorization_provider_id="str",
            authorization_id="str",
            parameters={"consentCode": "str"},
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...
