# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.apimanagement.aio import ApiManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer
from devtools_testutils.aio import recorded_by_proxy_async

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestApiManagementGraphQLApiResolverOperationsAsync(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(ApiManagementClient, is_async=True)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_graph_ql_api_resolver_list_by_api(self, resource_group):
        response = self.client.graph_ql_api_resolver.list_by_api(
            resource_group_name=resource_group.name,
            service_name="str",
            api_id="str",
            api_version="2024-05-01",
        )
        result = [r async for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_graph_ql_api_resolver_get_entity_tag(self, resource_group):
        response = await self.client.graph_ql_api_resolver.get_entity_tag(
            resource_group_name=resource_group.name,
            service_name="str",
            api_id="str",
            resolver_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_graph_ql_api_resolver_get(self, resource_group):
        response = await self.client.graph_ql_api_resolver.get(
            resource_group_name=resource_group.name,
            service_name="str",
            api_id="str",
            resolver_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_graph_ql_api_resolver_create_or_update(self, resource_group):
        response = await self.client.graph_ql_api_resolver.create_or_update(
            resource_group_name=resource_group.name,
            service_name="str",
            api_id="str",
            resolver_id="str",
            parameters={
                "description": "str",
                "displayName": "str",
                "id": "str",
                "name": "str",
                "path": "str",
                "type": "str",
            },
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_graph_ql_api_resolver_update(self, resource_group):
        response = await self.client.graph_ql_api_resolver.update(
            resource_group_name=resource_group.name,
            service_name="str",
            api_id="str",
            resolver_id="str",
            if_match="str",
            parameters={"description": "str", "displayName": "str", "path": "str"},
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_graph_ql_api_resolver_delete(self, resource_group):
        response = await self.client.graph_ql_api_resolver.delete(
            resource_group_name=resource_group.name,
            service_name="str",
            api_id="str",
            resolver_id="str",
            if_match="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...
