# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.apimanagement.aio import ApiManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer
from devtools_testutils.aio import recorded_by_proxy_async

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestApiManagementPolicyRestrictionOperationsAsync(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(ApiManagementClient, is_async=True)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_policy_restriction_list_by_service(self, resource_group):
        response = self.client.policy_restriction.list_by_service(
            resource_group_name=resource_group.name,
            service_name="str",
            api_version="2024-05-01",
        )
        result = [r async for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_policy_restriction_get_entity_tag(self, resource_group):
        response = await self.client.policy_restriction.get_entity_tag(
            resource_group_name=resource_group.name,
            service_name="str",
            policy_restriction_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_policy_restriction_get(self, resource_group):
        response = await self.client.policy_restriction.get(
            resource_group_name=resource_group.name,
            service_name="str",
            policy_restriction_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_policy_restriction_create_or_update(self, resource_group):
        response = await self.client.policy_restriction.create_or_update(
            resource_group_name=resource_group.name,
            service_name="str",
            policy_restriction_id="str",
            parameters={"id": "str", "name": "str", "requireBase": "false", "scope": "str", "type": "str"},
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_policy_restriction_update(self, resource_group):
        response = await self.client.policy_restriction.update(
            resource_group_name=resource_group.name,
            service_name="str",
            policy_restriction_id="str",
            if_match="str",
            parameters={"requireBase": "false", "scope": "str"},
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_policy_restriction_delete(self, resource_group):
        response = await self.client.policy_restriction.delete(
            resource_group_name=resource_group.name,
            service_name="str",
            policy_restriction_id="str",
            api_version="2024-05-01",
        )

        # please add some check logic here by yourself
        # ...
