# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.eventgrid.aio import EventGridManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer
from devtools_testutils.aio import recorded_by_proxy_async

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestEventGridManagementPartnerNamespacesOperationsAsync(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(EventGridManagementClient, is_async=True)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_get(self, resource_group):
        response = await self.client.partner_namespaces.get(
            resource_group_name=resource_group.name,
            partner_namespace_name="str",
            api_version="2025-02-15",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_begin_create_or_update(self, resource_group):
        response = await (
            await self.client.partner_namespaces.begin_create_or_update(
                resource_group_name=resource_group.name,
                partner_namespace_name="str",
                partner_namespace_info={
                    "location": "str",
                    "disableLocalAuth": False,
                    "endpoint": "str",
                    "id": "str",
                    "inboundIpRules": [{"action": "str", "ipMask": "str"}],
                    "minimumTlsVersionAllowed": "str",
                    "name": "str",
                    "partnerRegistrationFullyQualifiedId": "str",
                    "partnerTopicRoutingMode": "SourceEventAttribute",
                    "privateEndpointConnections": [
                        {
                            "groupIds": ["str"],
                            "id": "str",
                            "name": "str",
                            "privateEndpoint": {"id": "str"},
                            "privateLinkServiceConnectionState": {
                                "actionsRequired": "str",
                                "description": "str",
                                "status": "str",
                            },
                            "provisioningState": "str",
                            "type": "str",
                        }
                    ],
                    "provisioningState": "str",
                    "publicNetworkAccess": "str",
                    "systemData": {
                        "createdAt": "2020-02-20 00:00:00",
                        "createdBy": "str",
                        "createdByType": "str",
                        "lastModifiedAt": "2020-02-20 00:00:00",
                        "lastModifiedBy": "str",
                        "lastModifiedByType": "str",
                    },
                    "tags": {"str": "str"},
                    "type": "str",
                },
                api_version="2025-02-15",
            )
        ).result()  # call '.result()' to poll until service return final result

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_begin_delete(self, resource_group):
        response = await (
            await self.client.partner_namespaces.begin_delete(
                resource_group_name=resource_group.name,
                partner_namespace_name="str",
                api_version="2025-02-15",
            )
        ).result()  # call '.result()' to poll until service return final result

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_begin_update(self, resource_group):
        response = await (
            await self.client.partner_namespaces.begin_update(
                resource_group_name=resource_group.name,
                partner_namespace_name="str",
                partner_namespace_update_parameters={
                    "disableLocalAuth": bool,
                    "inboundIpRules": [{"action": "str", "ipMask": "str"}],
                    "minimumTlsVersionAllowed": "str",
                    "publicNetworkAccess": "str",
                    "tags": {"str": "str"},
                },
                api_version="2025-02-15",
            )
        ).result()  # call '.result()' to poll until service return final result

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_list_by_subscription(self, resource_group):
        response = self.client.partner_namespaces.list_by_subscription(
            api_version="2025-02-15",
        )
        result = [r async for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_list_by_resource_group(self, resource_group):
        response = self.client.partner_namespaces.list_by_resource_group(
            resource_group_name=resource_group.name,
            api_version="2025-02-15",
        )
        result = [r async for r in response]
        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_list_shared_access_keys(self, resource_group):
        response = await self.client.partner_namespaces.list_shared_access_keys(
            resource_group_name=resource_group.name,
            partner_namespace_name="str",
            api_version="2025-02-15",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy_async
    async def test_partner_namespaces_regenerate_key(self, resource_group):
        response = await self.client.partner_namespaces.regenerate_key(
            resource_group_name=resource_group.name,
            partner_namespace_name="str",
            regenerate_key_request={"keyName": "str"},
            api_version="2025-02-15",
        )

        # please add some check logic here by yourself
        # ...
