# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) Python Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from azure.identity import DefaultAzureCredential

from azure.mgmt.onlineexperimentation import OnlineExperimentationMgmtClient

"""
# PREREQUISITES
    pip install azure-identity
    pip install azure-mgmt-onlineexperimentation
# USAGE
    python online_experimentation_workspaces_get.py

    Before run the sample, please set the values of the client ID, tenant ID and client secret
    of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
    AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
    https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""


def main():
    client = OnlineExperimentationMgmtClient(
        credential=DefaultAzureCredential(),
        subscription_id="SUBSCRIPTION_ID",
    )

    response = client.online_experimentation_workspaces.get(
        resource_group_name="res9871",
        workspace_name="expworkspace3",
    )
    print(response)


# x-ms-original-file: 2025-05-31-preview/OnlineExperimentationWorkspaces_Get.json
if __name__ == "__main__":
    main()
