# pylint: disable=line-too-long,useless-suppression
# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) Python Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from azure.identity import DefaultAzureCredential

from azure.mgmt.programmableconnectivity import ProgrammableConnectivityMgmtClient

"""
# PREREQUISITES
    pip install azure-identity
    pip install azure-mgmt-programmableconnectivity
# USAGE
    python operator_api_connections_create_maximum_set_gen.py

    Before run the sample, please set the values of the client ID, tenant ID and client secret
    of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
    AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
    https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""


def main():
    client = ProgrammableConnectivityMgmtClient(
        credential=DefaultAzureCredential(),
        subscription_id="SUBSCRIPTION_ID",
    )

    response = client.operator_api_connections.begin_create(
        resource_group_name="rgopenapi",
        operator_api_connection_name="nzsdg",
        resource={
            "location": "dwvzfkjoepbmksygazllqryyinn",
            "properties": {
                "accountType": "AzureManaged",
                "appId": "czgrhbvgr",
                "appSecret": "wtxnpes",
                "configuredApplication": {
                    "applicationDescription": "gjlwegnqvffvsc",
                    "applicationType": "f",
                    "legalName": "ar",
                    "name": "idzqqen",
                    "organizationDescription": "fcueqzlxxr",
                    "privacyContactEmailAddress": "l",
                    "taxNumber": "ngzv",
                },
                "gatewayId": "/subscriptions/00000000-0000-0000-0000-00000000000/resourceGroups/example-rg/providers/Microsoft.ProgrammableConnectivity/gateways/cdvcixxcdhjqw",
                "operatorApiPlanId": "/subscriptions/00000000-0000-0000-0000-00000000000/providers/Microsoft.ProgrammableConnectivity/operatorApiPlans/livmzrh",
                "saasProperties": {"saasResourceId": "pekejefyvfviabimdrmno", "saasSubscriptionId": "mgyusmqt"},
                "status": {"reason": "fpteanxqzqixfmymib", "state": "rvez"},
            },
            "tags": {"key5536": "bjhvpzsmtalqxmjjbsfdizhg"},
        },
    ).result()
    print(response)


# x-ms-original-file: 2024-01-15-preview/OperatorApiConnections_Create_MaximumSet_Gen.json
if __name__ == "__main__":
    main()
